import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { Collapse, Fade, Grow, Slide, Zoom, } from "@mui/material";
import * as React from "react";
import { useEffect } from "react";
function usePrevious(value) {
    const ref = React.useRef();
    useEffect(() => {
        ref.current = value;
    });
    return ref.current || [];
}
function AnimatedListItem({ shown, children, timeout, onExited, animationProps, animation, }) {
    useEffect(() => {
        console.log("");
    }, [shown]);
    const componentMap = {
        grow: Grow,
        fade: Fade,
        slide: Slide,
        zoom: Zoom,
        collapse: Collapse,
    };
    const SelectedComponent = componentMap[animation];
    return (_jsx(SelectedComponent, { ...animationProps, timeout: timeout, in: shown, onExiting: onExited, children: _jsx("div", { children: children }) }));
}
export default function NerdAnimatedList({ children, animation = "grow", animationProps, initialAnimationDuration = 750, }) {
    const previousChildren = usePrevious(children);
    const [removed, setRemoved] = React.useState([]);
    const [removedShown, setRemovedShown] = React.useState([]);
    const removeChildren = () => {
        const newlyRemoved = previousChildren.filter((c) => children.findIndex((oc) => oc.key === c.key) === -1);
        newlyRemoved.forEach((r) => {
            const index = previousChildren.findIndex((rr) => r.key === rr.key);
            setRemoved({ ...removed, [index]: r });
            setRemovedShown({ ...removedShown, [index]: r });
            setTimeout(() => {
                delete removedShown[index];
                setRemovedShown({ ...removedShown });
            }, 100);
        });
    };
    useEffect(() => {
        if (previousChildren.length > children.length) {
            removeChildren();
        }
    }, [children]);
    const handleExit = (index) => {
        setTimeout(() => {
            delete removed[index];
            setRemoved({ ...removed });
        }, 300);
    };
    const getEnterDelayTime = (index) => {
        const delayTime = initialAnimationDuration * ((index + 1) / (children.length || 1));
        return delayTime;
    };
    return (_jsx(_Fragment, { children: children.length === 0 && removed[0] ? (_jsx(AnimatedListItem, { onExited: () => handleExit(0), shown: removedShown[0] !== undefined, timeout: { enter: 0 }, animation: animation, animationProps: animationProps, children: removed[0] }, removed[0].key)) : (children.map((Child, i) => (_jsxs(React.Fragment, { children: [i === 0 && removed[i] && (_jsx(AnimatedListItem, { animation: animation, onExited: () => handleExit(i), shown: removedShown[i] !== undefined, timeout: { enter: 0, exit: 200 }, children: removed[i] }, removed[i].key)), _jsx(AnimatedListItem, { animation: animation, animationProps: animationProps, shown: true, onExited: () => handleExit(Child.key), timeout: {
                        enter: previousChildren.find((p) => p.key === Child.key)
                            ? 0
                            : getEnterDelayTime(i),
                    }, children: Child }, Child.key || i), removed[i + 1] && (_jsx(AnimatedListItem, { animation: animation, animationProps: animationProps, onExited: () => handleExit(i + 1), shown: removedShown[i + 1] !== undefined, timeout: { enter: 0, exit: 500 }, children: removed[i + 1] }, removed[i + 1].key))] }, i)))) }));
}
