import { jsx as _jsx } from "react/jsx-runtime";
import { Visibility } from "@mui/icons-material";
import { Chip, ChipDelete } from "@mui/joy";
import { useTranslation } from "react-i18next";
import nerdUII18n from "../i18n";
/**
 * @param {NerdImpersonateProps} props props
 * @returns {ReactElement} Button to stop impersonate a user. Should be placed in the NerdAppBar configuration
 */
export function NerdImpersonate(props) {
    const { user, onStopImpersonate } = props;
    const { t } = useTranslation("components", { i18n: nerdUII18n });
    return user.impersonate ? (_jsx(Chip, { startDecorator: _jsx(Visibility, {}), endDecorator: _jsx(ChipDelete, { onDelete: onStopImpersonate }), sx: {
            mr: 1,
        }, color: "danger", children: `${t("nerdImpersonate.impersonating")} ${user.firstName} ${user.lastName}` })) : null;
}
