import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { FirstPage, KeyboardArrowLeft, KeyboardArrowRight, } from "@mui/icons-material";
import { Box, Tooltip, IconButton } from "@mui/material";
import { useTranslation } from "react-i18next";
import nerdUII18n from "../../i18n";
const CustomArrow = ({ onPageChange, page, disabledNext, children, }) => {
    const disablePrev = page === 1;
    const { t } = useTranslation("components", { i18n: nerdUII18n });
    return (_jsxs(Box, { children: [_jsx(Tooltip, { title: `${t("nerdPagination.first")} ${t("nerdPagination.page")}`, placement: "bottom", enterDelay: 300, children: _jsx("span", { children: _jsx(IconButton, { onClick: (e) => onPageChange(e, 1), disabled: disablePrev, "aria-label": `${t("nerdPagination.first")} ${t("nerdPagination.page")}`, children: _jsx(FirstPage, {}) }) }) }), _jsx(Tooltip, { title: `${t("nerdPagination.prev")} ${t("nerdPagination.page")}`, placement: "bottom", enterDelay: 300, children: _jsx("span", { children: _jsx(IconButton, { onClick: (e) => onPageChange(e, page - 1), disabled: disablePrev, "aria-label": `${t("nerdPagination.previous")} ${t("nerdPagination.page")}`, children: _jsx(KeyboardArrowLeft, {}) }) }) }), children, _jsx(Tooltip, { title: `${t("nerdPagination.next")} ${t("nerdPagination.page")}`, placement: "bottom", enterDelay: 300, children: _jsx("span", { children: _jsx(IconButton, { onClick: (e) => {
                            onPageChange(e, page + 1);
                        }, "aria-label": `${t("nerdPagination.next")} ${t("nerdPagination.page")}`, disabled: disabledNext, children: _jsx(KeyboardArrowRight, {}) }) }) })] }));
};
export default CustomArrow;
